// winpdpView.cpp : implementation of the CWinpdpView class
//

#include "stdafx.h"
#include "winpdp.h"

#include "winpdpDoc.h"
#include "winpdpView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWinpdpView

IMPLEMENT_DYNCREATE(CWinpdpView, CEditView)

BEGIN_MESSAGE_MAP(CWinpdpView, CEditView)
	//{{AFX_MSG_MAP(CWinpdpView)
	ON_WM_CHAR()
	ON_WM_CREATE()
	ON_COMMAND(ID_FONT, OnFont)
	ON_COMMAND(ID_BREAK, OnBreak)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWinpdpView construction/destruction

CWinpdpView *gView;

CWinpdpView::CWinpdpView()
{
	// TODO: add construction code here
	gView = this;

	rbHead = rbTail = 0;
	Raw = FALSE;
	curFont = 0;
	bBreak = false;
}

CWinpdpView::~CWinpdpView()
{
}


BOOL CWinpdpView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CEditView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CWinpdpView drawing

void CWinpdpView::OnDraw(CDC* pDC)
{
	CWinpdpDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CWinpdpView diagnostics

#ifdef _DEBUG
void CWinpdpView::AssertValid() const
{
	CEditView::AssertValid();
}

void CWinpdpView::Dump(CDumpContext& dc) const
{
	CEditView::Dump(dc);
}

CWinpdpDoc* CWinpdpView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CWinpdpDoc)));
	return (CWinpdpDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CWinpdpView message handlers

void CWinpdpView::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
	if (nRepCnt != 2) {
		rb[rbHead++] = nChar;
		rbHead &= RB_SIZE;
		if (Raw)
			return;
	} 
	
	CEditView::OnChar(nChar, nRepCnt, nFlags);
}

int CWinpdpView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CEditView::OnCreate(lpCreateStruct) == -1)
		return -1;

	   // get current font description
	OnFont();
#if 0
#if 1
	CFont* pFont = new CFont;
	LOGFONT lf;

	   ::GetObject(GetStockObject(SYSTEM_FONT), sizeof(LOGFONT), &lf);

		if (pFont->CreateFontIndirect(&lf))
		{
			CWaitCursor wait;
			SetFont(pFont);
		}
#else
	CFont font;
VERIFY(font.CreateFont(
   8,                        // nHeight
   0,                         // nWidth
   0,                         // nEscapement
   0,                         // nOrientation
   FW_NORMAL,                 // nWeight
   FALSE,                     // bItalic
   FALSE,                     // bUnderline
   0,                         // cStrikeOut
   ANSI_CHARSET,              // nCharSet
   OUT_DEFAULT_PRECIS,        // nOutPrecision
   CLIP_DEFAULT_PRECIS,       // nClipPrecision
   DEFAULT_QUALITY,           // nQuality
   FIXED_PITCH ,  // nPitchAndFamily
   _T("Courier New")));                 // lpszFacename
			
SetFont(&font);
#endif
#endif	
	// TODO: Add your specialized creation code here
	
	return 0;
}

LOGFONT lf[] = {
			{ 8, 5, 0, 0, 400, 0, 0,0,0,0,0,0,0, _T("Courier New") },
			{ 12, 0, 0, 0, 400, 0, 0,0,0,0,0,0,0, _T("Courier New") },
			{ 6, 0, 0, 0, 400, 0, 0,0,0,0,0,0,0, _T("Courier New") },
			{ 7, 0, 0, 0, 400, 0, 0,0,0,0,0,0,0, _T("Courier New") },
			{ 7, 0, 0, 0, 400, 0, 0,0,0,0,0,0,0, _T("") },
			{ 0 }};

void CWinpdpView::OnFont() 
{ 
	// TODO: Add your command handler code here

#if 1
	CFont* pFont = new CFont;
	LOGFONT default_lf;

	::GetObject(GetStockObject(SYSTEM_FONT), sizeof(LOGFONT), &default_lf);


		if (lf[curFont].lfHeight == 0) {
			if (pFont->CreateFontIndirect(&default_lf))
			{
				CWaitCursor wait;
				SetFont(pFont);
				curFont = 0;
			}
		} else {
			if (pFont->CreateFontIndirect(&lf[curFont++]))
			{
				CWaitCursor wait;
				SetFont(pFont);
			}
		}
#else

	HFONT  hFont;
	LOGFONT lf = { 8, 5, 0, 0, 400, 0, 0,0,0,0,0,0,0, _T("Courier New") };

	HDC hdc = ::GetDC( m_hWnd );
	
	hFont = (HFONT)SelectObject( hdc, CreateFontIndirect( &lf ) );
			
//	SetFont(&hFont);

	DeleteObject( SelectObject( hdc, hFont ) );
	::ReleaseDC( m_hWnd, hdc );
			
//SetFont(&font);
#if 0
	HWND hwnd = m_hWnd;                // owner window

CHOOSEFONT cf;            // common dialog box structure
static LOGFONT lf;        // logical font structure
static DWORD rgbCurrent;   // current text color
CFont* pFont = new CFont;
DWORD rgbPrev;

// Initialize CHOOSEFONT
ZeroMemory(&cf, sizeof(CHOOSEFONT));
cf.lStructSize = sizeof (CHOOSEFONT);
cf.hwndOwner = hwnd;
cf.lpLogFont = &lf;
cf.rgbColors = rgbCurrent;
cf.Flags = CF_SCREENFONTS | CF_EFFECTS;

if (ChooseFont(&cf)) {
		if (pFont->CreateFontIndirect(cf.lpLogFont))
		{
			
			SetFont(pFont);
		}
}

#endif	
#endif
}

void CWinpdpView::OnBreak() 
{
	bBreak = true;
}
